%%% Programme Patrick 09/2007

% tveq_TFR_example.m
%
% Phantom reconstruction from samples on 22 radial lines in the Fourier
% plane.
%
% Written by: Justin Romberg, Caltech
% Email: jrom@acm.caltech.edu
% Created: October 2005
%



path(path, './Optimization');
path(path, './Measurements');
path(path, './Data');


% % Phantom 
% n = 64;
% N = n*n;
% X = phantom(n);
% x = X(:);

n = 256 ;
s = amgauss(n,n/2,n/2).*fmsin(n,0.1,0.4,n/2) + fmlin(n,0.1,0.05)/2 + randn(n,1)/5 ;
X = tfrwv(s) ;
x = X(:) ;
% a = fft2(w) ;
% as = fftshift(a) ;
% d = n/8 ;
% m = zeros(n,n) ;
% m(n/2-d/2:n/2+d/2,n/2-d/2:n/2+d/2) = ones(d+1,d+1) ;
% asm = as.*m ;
% am = fftshift(asm) ;

% number of radial lines in the Fourier domain
% L = 12;

% Fourier samples we are given
% [M,Mh,mh,mhi] = LineMask(L,n);
N = n ;
M = zeros(N) ;
d = n/8 ;
M(n/2-d/2:n/2+d/2,n/2-d/2:n/2+d/2) = ones(d+1) ;

% upper half plane mask (not including origin)
Mh = zeros(N) ;
Mh = M;
Mh(N/2+2:N,:) = 0;
Mh(N/2+1,N/2+1:N) = 0;

M = ifftshift(M);
mi = find(M);
Mh = ifftshift(Mh);
mhi = find(Mh);

OMEGA = mhi;
A = @(z) A_fhp(z, OMEGA);
At = @(z) At_fhp(z, OMEGA, n);

% measurements
y = A(x);

% min l2 reconstruction (backprojection)
xbp = At(y);
Xbp = reshape(xbp,n,n);

% recovery
tic
% tvI = sum(sum(sqrt([diff(X,1,2) zeros(n,1)].^2 + [diff(X,1,1); zeros(1,n)].^2 )));
% disp(sprintf('Original TV = %8.3f', tvI));
xp = tveq_logbarrier(xbp, A, At, y, 1e-1, 2, 1e-6, 100);
Xtv = reshape(xp, n, n);
toc
